# Iron Wall
import es,time,gamethread,ConfigParser,os
from lib import ironupdate

_path = es.getAddonPath('ironwall') 

log_players = True
log_details = True
check_updates = True

_overflow_limit = 5
_overflow_count = 0
_overflow_time = 5

_version = '0.1'

_password = None

if os.path.exists(_path+'/settings/settings.ini'):
    config = ConfigParser.ConfigParser()
    config.read(_path+'/settings/settings.ini')
    log_players = config.get('log_settings','log players') == '1'
    log_details = config.get('log_settings','log details') == '1'
    check_updates = config.get('log_settings','check updates') == '1'
    _overflow_limit = int(config.get('overflow_settings','limit'))
    _overflow_time = int(config.get('overflow_settings','time'))
    _password = config.get('security','password')
else:
    # make this file fool
    config = ConfigParser.ConfigParser()
    config.add_section('log_settings')
    config.set('log_settings','log players','1')
    config.set('log_settings','log details','1')
    config.set('log_settings','check updates','1')
    config.add_section('overflow_settings')
    config.set('overflow_settings','limit','5')
    config.set('overflow_settings','time','5')
    config.add_section('security')
    config.set('security','password','None')
    a = open(_path+'/settings/settings.ini','w')
    config.write(a)
    a.close()

# Default cvar values
cvars = {'rcon_password':'',
         'sv_cheats':'0',
         'eventscripts_protectrcon':'1'}

if os.path.exists(_path+'/settings/cvars.txt'):
    a = open(_path+'/settings/cvars.txt')
    lines = a.readlines()
    for i in lines:
        cvar,value = i.replace('\n','').split(' ',1)
        cvars[cvar] = value
    a.close()
else:
    print 'cvars.txt not found - no cvar forcing will be done'

client_cvars = {'sv_cheats':'0'}

if os.path.exists(_path+'/settings/client_cvars.txt'):
    a = open(_path+'/settings/client_cvars.txt')
    lines = a.readlines()
    for i in lines:
        cvar,value = i.replace('\n','').split(' ',1)
        client_cvars[cvar] = value
    a.close()
else:
    print 'client_cvars.txt not found - no cvar checking will be done'

banned_commands = []

if os.path.exists(_path+'/settings/banned_commands.txt'):
    a = open(_path+'/settings/banned_commands.txt')
    lines = a.readlines()
    for i in lines:
        banned_commands.append(i.replace('\n',''))
    a.close()
else:
    print 'banned_commands.txt not found - no cvar checking will be done'

es.set('ironwall_version',_version)
es.makepublic('ironwall_version')
_update_needed = False

def load():
    es.log('[IRONWALL] Has been loaded')
    msg('IRONWALL loaded - Your server is now protected')
    for i in cvars:
        es.flags('add','notify',i)
    if 'rcon_password' in cvars:
        es.set('rcon_password',cvars['rcon_password'])
    gamethread.delayedname(5,'_ironwall_ticker',_looper)
    es.regcmd('list_hooked_cvars','ironwall/list_cvars')
    es.regcmd('list_banned_commands','ironwall/list_commands')
    if check_updates:
        globals()['_update_needed'] = ironupdate.check_for_update(_version)

def list_cvars():
    print ' '
    print '     Protected CVARS'
    print '-------------------------'
    for i in cvars:
        print i+' - '+cvars[i]
    print '-------------------------'

def list_commands():
    print ' '
    print '     Banned Commands'
    print '-------------------------'
    for i in banned_commands:
        print i
    print '-------------------------'

def server_cvar(ev):
    if ev['cvarname'] in cvars:
        if not ev['cvarvalue'] == cvars[ev['cvarname']]:
            es.set(ev['cvarname'],cvars[ev['cvarname']])
            msg('IronWall has prevented a CVAR change')
            es.log('------------------------IRONWALL------------------------')
            es.log('Iron wall has prevented %s from being changed'%ev['cvarname'])
            t_ime = str(time.time())
            if log_details:
                es.log('Details:')
                es.log(' -Cvarname    : %s'%ev['cvarname'])
                es.log(' -Changed to  : %s'%ev['cvarvalue'])
                es.log(' -Player count: %s'%str(len(es.getUseridList())))
                es.log(' -Map         : %s'%es.ServerVar('eventscripts_currentmap'))
                es.log(' -Steamid list: %s'%t_ime+'.txt')
            es.log('--------------------------------------------------------')
            global _overflow_count,_overflow_limit
            print _overflow_count
            if not _overflow_count == _overflow_limit:
                _overflow_count+=1
                if log_players: _writeplayers(t_ime)
            else:
                print 'Overflow limit has been reached - No logging of players'
                       
                
def player_activate(ev):
    if ev['es_username'] in ['0','']:
        es.ServerCommand('kickid %s "Use a real name"'%ev['userid'])
        msg('Kicked #green%s#default for using the unconnected exploit'%ev['es_steamid'])

def player_spawn(ev):
    uid = ev['userid']
    # Check their shit
    for i in client_cvars:
        es.queryclientvar(uid,i)

def es_player_variable(ev):
    if ev['status'] == 'success':
        if ev['variable'] in client_cvars:
            if not ev['value'] == client_cvars[ev['variable']]:
                # Kick this crazy goon
                es.ServerCommand('kickid %s "Cvar %s does not match the servers"'%(ev['userid'],ev['variable']))
                msg('Kicked #green%s#default for having incorrect variables'%es.getplayersteamid(ev['userid']))
                es.log('Kicked %s - Var %s set to %s when it should be %s'%(es.getplayersteamid(ev['userid']),ev['variable'],ev['value'],client_cvars[ev['variable']]))
        
def msg(msg):
    es.msg('#multi','#lightgreen[IRONWALL]#default %s'%msg)

def round_start(ev):
    global _update_needed
    msg('This server is protected by #lightgreen[IRONWALL]#default version %s'%_version)
    print _update_needed
    if _update_needed:
        msg('There is a new version of #lightgreen[IRONWALL]#default available - please re-download')
        es.log('[IRONWALL] There is a new version of IRONWALL available - please re-download')

def _writeplayers(logfile):
    print 'Writing players'
    steamids = []
    userids = es.getUseridList()
    for uid in userids:
        id = es.getplayersteamid(uid)
        if not id == 'BOT':
            steamids.append(id)
    if not steamids: return
    a = open(es.getAddonPath('ironwall')+'\\players\\%s.txt'%str(logfile),'w')
    for i in steamids:
        a.write(i+'\n')
    a.close()
    print 'Done'

def _looper():
    globals()['_overflow_count'] = 0
    gamethread.delayedname(5,'_ironwall_ticker',_looper)

def unload():
    msg('IRONWALL was unloaded - Reloading')
    gamethread.cancelDelayed('_ironwall_ticker')
    es.log('[IRONWALL] Was unloaded. Re-loading')
    es.ServerCommand('es_xdelayed 0 es_load ironwall')
